level = {}
function level.load()
	level.music = "music/maf - surgele.mp3"
	-- Blizzard ----------------------------------------------------------------------
	blizzard.image = love.graphics.newImage("gfx/blizzard.png")
	blizzard.flake = love.graphics.newImage("gfx/snowbig.png")
	blizzard.alpha = 0
	blizzard.rate = 0
	blizzard.minSpeed = speed * 1.5
	blizzard.maxSpeed = speed * 1.5
	blizzard.snow = love.graphics.newParticleSystem(blizzard.flake, 10000)
	blizzard.snow:setEmissionRate(blizzard.rate)
	blizzard.snow:setParticleLifetime(6)
	blizzard.snow:setAreaSpread("normal", 480, 0)
	blizzard.snow:setPosition(0, 640)
	blizzard.snow:setDirection(math.rad(270))
	blizzard.snow:setSpread(blizzard.rate)
	blizzard.snow:setSpeed(blizzard.minSpeed, blizzard.maxSpeed)
	blizzard.snow:setSizes(0.5, 1, 1.5)
	blizzard.snow:setSizeVariation(1)
	blizzard.snow:setSpin(1, 4)
	blizzard.snow:stop()
	-- Avalanche -----------------------------------------------------------------------
	avalanche = {}
	avalanche.halo = love.graphics.newImage("gfx/avalanche_halo.png")
	avalanche.sound = "sfx/avalanche.ogg"
	avalanche.volume = 1
	avalanche.bit = love.graphics.newImage"gfx/boule.png"
	rgb1 = 255
	rgb2 = 235
	rgb3 = 215
	rgb4 = 195
	avalanche.alpha = 255
	avalanche.particles = love.graphics.newParticleSystem(avalanche.bit, 20000)
	avalanche.particles:setColors(rgb1, rgb1, rgb1, avalanche.alpha, rgb2, rgb2, rgb2, avalanche.alpha, rgb3, rgb3, rgb3, avalanche.alpha, rgb4, rgb4, rgb4, avalanche.alpha)
	avalanche.particles:setLinearAcceleration(0, -500, 0, -10)
	avalanche.particles:setEmissionRate(0)
  	avalanche.particles:setParticleLifetime(0.3)
  	avalanche.particles:setAreaSpread("normal", 480, 0)
  	avalanche.particles:setPosition(0, 24)
  	avalanche.particles:setDirection(math.rad(90))
  	avalanche.particles:setSpread(8000)
  	avalanche.particles:setSpeed(200, 300)
  	avalanche.particles:setSizes(0.5, 1, 1.5, 2)
  	avalanche.particles:setSizeVariation(1)
  	avalanche.particles:setSpin(1, 10)
  	avalanche.particles:setEmissionRate(5000)
  	avalanche.particles:start()
	-- Foregroound elements ------------------------------------------------------------
	obstacles = {}
	shadows = {}
	-- Background elements -------------------------------------------------------------
	skier.m1 = love.graphics.newImage("gfx/marks.png")
	skier.m2 = love.graphics.newImage("gfx/marks2.png")
	if skier.label == "skier" then
		marks = skier.m1
	elseif skier.label == "snowboarder" then
		marks = skier.m2
	end
	slope = {}
	slope.texture = {}
	for i = 1, 16 do
		if i < 10 then
			slope.texture[i] = love.graphics.newImage("gfx/bg0"..tostring(i)..".png")
		elseif i >= 10 then
			slope.texture[i] = love.graphics.newImage("gfx/bg"..tostring(i)..".png")
		end
	end
	bg = {}
	local x = 0
	local y = 0
	for i = 1, 300 do
		local t = {}
		t.x = x
		t.y = y
		t.image = slope.texture[math.random(16)]
		table.insert(bg, t)
		y = y + 32
		if y > 632 then
			y = 0
			x = x + 32
		end
	end
end
function level.update(dt)
	-- Avalanche ----------------------------------------------
	avalanche.particles:start()
	avalanche.particles:update(dt)
	-- Blizzard -----------------------------------------------
	if blizzard.isActive == true then
		blizzard.snow:start()
		blizzard.snow:update(dt)
		blizzard.alpha = blizzard.alpha + dt
		if blizzard.alpha >  110 then
			blizzard.alpha = 110
		end
		blizzard.minSpeed = speed * 1.5
		blizzard.maxSpeed = speed * 1.5
		blizzard.snow:setSpeed(blizzard.minSpeed, blizzard.maxSpeed)
		blizzard.rate = blizzard.rate + dt * 5
		blizzard.snow:setEmissionRate(math.floor(blizzard.rate))
	end
	avalanche.volume = 1 / skier.y * 200
	if avalanche.volume > 1 then
		avalanche.volume = 1
	end
	TEsound.volume("sfx", avalanche.volume)
	distance = distance + dt * speed / 20
	speed = speed + dt * 2
	if timer.smooth > 10 then
		timer.smooth = 0
		timer.raw = 0
		bonus.value = bonus.value * 2
	end
	-- Background
	create_mark()
	for i, v in ipairs(skier.marks) do
		v.y = v.y - dt * speed
		if v.y < -1 then
			table.remove(skier.marks, i)
		end
	end
	for i, v in ipairs(bg) do
		v.y = v.y - dt * speed
		if v.y < -32 then
			v.y = v.y + 632
		end
	end
	local go = math.random(100)
	if go > 97 then
		create_obstacle()
	end
	-- Foreground
	for i,v in ipairs(bonus.table) do
			v.y = v.y - dt * speed
			v.alpha = v.alpha - dt * 400
			if v.alpha < 0 then
				table.remove(bonus.table, i)
			end
		end
	for i, v in ipairs(obstacles) do
		v.particles:start()
		v.particles:update(dt)
		v.particles:setPosition(v.x, v.y)
		v.y = v.y -dt * speed
		v.box:moveTo(v.x, v.y)
		if v.y < -v.h then
			table.remove(obstacles, i)
		end
	end
	for i, v in ipairs(shadows) do
		v.y = v.y -dt * speed
		if v.y < -v.h then
			table.remove(shadows, i)
		end
	end
end
function level.bg_draw()
	for i, v in ipairs(bg) do
		love.graphics.draw(v.image, v.x, v.y)
	end
	for i, v in ipairs(skier.marks) do
		love.graphics.draw(marks, v.x, v.y, 0, 1, speed / 50)
	end
end
function level.fg_draw()
	for i, v in ipairs(shadows) do
		love.graphics.draw(v.image, v.x, v.y)
	end
	love.graphics.draw(avalanche.halo, 0, 0)
	for i, v in ipairs(obstacles) do
		if v.y > 24 then
			love.graphics.draw(v.image, v.x, v.y, 0, 1, 1, v.w/2, v.h/2)
			--love.graphics.draw(v.particles, 0, 0)
		else
			love.graphics.draw(v.particles, v.x, v.y)
		end
		if dbug.show == true then
			v.box:draw("line")
		end
	end
	love.graphics.draw(avalanche.particles, 0, 0)
	-- Blizzard -------------------------------------------------------------------------
	if blizzard.isActive == true then
		love.graphics.setColor(255, 255, 255, math.floor(blizzard.alpha * 2))
		love.graphics.draw(blizzard.image, 0, 0)
		love.graphics.setColor(255, 255, 255, 255)
		love.graphics.draw(blizzard.snow, 0, 0)
	end
	for i, v in ipairs(bonus.table) do
		love.graphics.setFont(bonus.font)
		love.graphics.setColor(255, 255, 255, v.alpha)
		love.graphics.print("+"..tostring(bonus.value), v.x, v.y)
		love.graphics.setFont(score.font)
	end
	love.graphics.setColor(255, 255, 255, 255)
end
function create_obstacle()
	local t = {}
	local s = {}
	local r = math.random(6)
	t.image = love.graphics.newImage("gfx/obstacle0"..r..".png")
	local bit = love.graphics.newImage("gfx/obstacle0"..r.."p.png")
	s.image = love.graphics.newImage("gfx/obstacle0"..r.."s.png")
	t.w = t.image:getWidth()
	t.h = t.image:getHeight()
	s.h = s.image:getHeight()
	t.x = math.random(480)
	t.y = 600 + t.h
	t.particles = love.graphics.newParticleSystem(bit, 30)
	t.particles:setEmissionRate(20)
	t.particles:setParticleLifetime(0.4)
	t.particles:setPosition(t.x, t.y)
	t.particles:setSpread(2)
	t.particles:setSpeed(200, 250)
	t.particles:setSizes(1, 0.8, 0.6, 0.4, 0.2)
	t.particles:setSpin(1, 10)
	t.particles:setDirection(math.rad(270))
	t.particles:stop()
	s.x = t.x - t.w * 1.5
	s.y = t.y + t.h / 2.5
	t.box = Collider:addRectangle(t.x, t.y, math.floor(0.7 * t.w), math.floor(0.5 * t.h))
	Collider:addToGroup("obstacles", t.box)
	table.insert(obstacles, t)
	table.insert(shadows, s)
end
function create_mark()
	local t = {}
	t.x = skier.x - 10
	t.y = skier.y
	table.insert(skier.marks, t)
end
function collision(box, dt)
	if box.type == "skier" then
		if skier.isAlive == true then
			skier.playbump = true
		end
		skier.isAlive = false
	end
end