HC = require "libs/hardoncollider"
require "libs/AnAL"
require "libs/TEsound"
require "menu"
require "skier"
require "level"
require "dbug"
function love.load()
	timer = {}
	speed = 150
	record = {}
	record.best = 0
	record.open = false
	record.timer = 0
	timer.raw = 0
	timer.smooth = 0
	state = "menu"
	game_over.load()
	Collider = HC(100, on_collision)
	distance = 1
	skier.load()
	menu.load()
	level.load()
	dbug.load()
end
function love.update(dt)
	if score.value > score.hi then
		score.hi = score.value
	end
	TEsound.cleanup()
	Collider:update(dt)
	if state == "menu" then
		speed = 150
		score.value = 0
		bonus.value = 1
		timer.raw = 0
		blizzard.go = 100
		menu.update(dt)
	elseif state == "options" then
		menu.update(dt)
		options.update(dt)
	elseif state == "game" then
		timer.raw = timer.raw + dt
		timer.smooth = math.floor(timer.raw)
		score.value = score.value + dt * 10
		if record.open == true then
			if distance > record.best then
				record.timer = record.timer + dt
			end
		end
		skier.update(dt)
		level.update(dt)
	elseif state == "test" then
		particles:start()
		particles:update(dt)
	end
end
function love.draw()
	if state == "menu" then
		menu.draw()
	elseif state == "options" then
		options.draw()
	elseif state == "game" then
		level.bg_draw()
		skier.draw()
		level.fg_draw()
		love.graphics.draw(skier.panel, 352, 536)
		love.graphics.setFont(skier.font)
		love.graphics.print(round(speed + skier.y/10, 2)-130, 360, 546)
		if record.timer > 0 then
			love.graphics.print("RECORD", 360, 572)
			if record.timer > 1.5 then
				record.timer = 0
				record.open = false
			end
		else
			love.graphics.print(round(distance, 2), 360, 572)
		end
		if dbug.show == true then
			dbug.draw()
		end
		love.graphics.setFont(score.font)
		love.graphics.printf(tostring(math.floor(score.value)), 0, 7, 480, "center")
	elseif state == "game_over" then
		record.timer = 0
		game_over.draw()
	end
end








-- Global functions
function round(number, amount)
	local multi = 10^(amount or 0)
	return math.floor(number * multi + 0.5) / multi
end
function love.keypressed(key)
	if state == "menu" then
		if key == "down" then
			if menu.position == 1 then
				menu.position = 2
			elseif menu.position == 2 then
				menu.position = 3
			elseif menu.position == 3 then
				menu.position = 1
			end
		elseif key == "up" then
			if menu.position == 1 then
				menu.position = 3
			elseif menu.position == 2 then
				menu.position = 1
			elseif menu.position == 3 then
				menu.position = 2
			end
		elseif key == "return" then
			if menu.position == 1 then
				record.open = true
				TEsound.playLooping(avalanche.sound, "sfx")
				TEsound.playLooping(level.music, "music")
				TEsound.volume("music", 0.6)
				state = "game"
			elseif menu.position == 2 then
				state = "options"
				menu.position = 1
			elseif menu.position == 3 then
				love.event.quit()
			end
		end
	elseif state == "options" then
		if key == "down" then
			if menu.position == 1 then
				menu.position = 2
			elseif menu.position == 2 then
				menu.position = 3
			elseif menu.position == 3 then
				menu.position = 1
			end
		elseif key == "up" then
			if menu.position == 1 then
				menu.position = 3
			elseif menu.position == 2 then
				menu.position = 1
			elseif menu.position == 3 then
				menu.position = 2
			end
		elseif key == "left" then
			if menu.position == 1 then
				if skier.label == "skier" then
					skier.label = "snowboarder"
				elseif skier.label == "snowboarder" then
					skier.label = "skier"
				end
			elseif menu.position == 2 then
				if blizzard.isActive == true then
					blizzard.isActive = false
				elseif blizzard.isActive == false then
					blizzard.isActive = true
				end
			end
		elseif key == "right" then
			if menu.position == 1 then
				if skier.label == "skier" then
					skier.label = "snowboarder"
				elseif skier.label == "snowboarder" then
					skier.label = "skier"
				end
			elseif menu.position == 2 then
				if blizzard.isActive == true then
					blizzard.isActive = false
				elseif blizzard.isActive == false then
					blizzard.isActive = true
				end
			end
		elseif key == "return" then
			if menu.position == 3 then
				menu.position = 1
				state = "menu"
			end
		end
	elseif state == "game_over" then
		if key == "return" then
			Collider:clear()
			distance = 0
			level.load()
			speed = 150
			skier.load()
			love.graphics.setFont(menu.font)
			state = "menu"
		end
	end
end
function on_collision(dt, object1, object2)
	if object1.type == "skier" then
		collision(object1, dt)
	elseif object2.type == "skier" then
		collision(object2, dt)
	end
	if object1.type == "grinder" then
		bonus.timer = bonus.timer + dt
	elseif object2.type == "grinder" then
		bonus.timer = bonus.timer + dt
	end
end