-- Main menu -----------------------------------------------------------------------------------------------------------------
menu = {}
function menu.load()
	blizzard = {}
	blizzard.isActive = true
	skier.label = "skier"
	skier.image = skier.skier
	menu.skier = love.graphics.newImage("gfx/cordonnier.png")
	menu.snowboarder = love.graphics.newImage("gfx/shoemaker.png")
	menu.joke = menu.skier
	menu.bg = love.graphics.newImage("gfx/menubg.jpg")
	menu.title = love.graphics.newImage("gfx/title.png")
	score = {}
	score.font = love.graphics.newImageFont("gfx/score.png", "0123456789")
	score.value = 0
	score.hi = 0
	menu.font = love.graphics.newImageFont("gfx/kromagrad_16x16.png", "!-+*% '()./0123456789:;<=>?@abcdefghijklmnopqrstuvwxyz")
	love.graphics.setFont(menu.font)
	menu.position = 1
	menu.colors = {255, 128, 128}
end
function menu.update(dt)
	if menu.position == 1 then
		menu.colors[1] = 255
		menu.colors[2] = 128
		menu.colors[3] = 128
	elseif menu.position == 2 then
		menu.colors[1] = 128
		menu.colors[2] = 255
		menu.colors[3] = 128
	elseif menu.position == 3 then
		menu.colors[1] = 128
		menu.colors[2] = 128
		menu.colors[3] = 255
	end
end
function menu.draw()
	love.graphics.setColor(255, 255, 255)
	love.graphics.draw(menu.bg, 0, 0)
	love.graphics.draw(menu.title, 130, 50)
	love.graphics.draw(menu.joke, 300, 300)
	love.graphics.setColor(menu.colors[1],menu.colors[1],menu.colors[1])
	love.graphics.print("start", 200, 300)
	love.graphics.setColor(menu.colors[2],menu.colors[2],menu.colors[2])
	love.graphics.print("options", 200, 320)
	love.graphics.setColor(menu.colors[3],menu.colors[3],menu.colors[3])
	love.graphics.print("exit", 200, 340)
	love.graphics.setColor(255, 255, 255)
	if dbug.show == true then
		love.graphics.print("position: "..tostring(menu.position), 10, 10)
		love.graphics.print("state: "..state, 10, 25)
		love.graphics.print("lbl: "..skier.label, 10, 40)
	end
end
-- Options Menu ------------------------------------------------------------------------------------------------------------
options = {}
function options.load()
end
function options.update(dt)
	if skier.label == "skier" then
		skier.image = skier.skier
		menu.joke = menu.skier
		marks = skier.m1
	elseif skier.label == "snowboarder" then
		skier.image = skier.snowboarder
		menu.joke = menu.snowboarder
		marks = skier.m2
	end
end
function options.draw()
	love.graphics.setColor(255, 255, 255)
	love.graphics.draw(menu.bg, 0, 0)
	love.graphics.draw(menu.title, 130, 50)
	love.graphics.draw(menu.joke, 300, 300)
	love.graphics.setColor(menu.colors[1],menu.colors[1],menu.colors[1])
	love.graphics.print("player: "..skier.label, 100, 300)
	love.graphics.setColor(menu.colors[2],menu.colors[2],menu.colors[2])
	love.graphics.print("blizzard: "..tostring(blizzard.isActive), 100, 320)
	love.graphics.setColor(menu.colors[3],menu.colors[3],menu.colors[3])
	love.graphics.print("back", 100, 340)
	if dbug.show == true then
		love.graphics.print("lbl: "..skier.label, 0, 0)
	end
end
-- Game over menu ----------------------------------------------------------------------------------------------------------
game_over = {}
function game_over.load()
	game_over.screen = love.graphics.newImage("gfx/over.jpg")
end
function game_over.update(dt)
	-- body
end
function game_over.draw()
	love.graphics.draw(game_over.screen, 0, 0)
	love.graphics.setNewFont("gfx/Kill Em All.ttf", 150)
	love.graphics.print("game over", 10, 400)
	love.graphics.setFont(score.font)
	love.graphics.printf(tostring(math.floor(score.value)), 0, 10, 480, "center")
	love.graphics.printf(tostring(math.floor(score.hi)), 0, 80, 480, "center")
	love.graphics.setFont(menu.font)
	love.graphics.printf("hi score", 0, 60, 480, "center")
end