skier = {}
function skier.load()
	bonus = {}
	bonus.font = love.graphics.newImageFont("gfx/bonus.png", "+./0123456789")
	bonus.sound = "sfx/bonus.ogg"
	bonus.table = {}
	bonus.timer = 0
	bonus.value = 1
	bonus.alpha = 255
	local pic = love.graphics.newImage("gfx/explosion.png")
	skier.font = love.graphics.newImageFont("gfx/digifont_16x16.png", '!"Ó%'.."'() +,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ")
	skier.panel = love.graphics.newImage("gfx/cpanel.png")
	skier.explosion = newAnimation(pic, 64, 64, 0.1, 0)
	skier.explosion:setMode("once")
	skier.skier = love.graphics.newImage("gfx/skier.png")
	skier.snowboarder = love.graphics.newImage("gfx/snowboarder.png")
	skier.bump = "sfx/bump.ogg"
	skier.isAlive = true
	skier.playbump = false
	skier.angle = 90
	skier.marks = {}
	skier.speed = speed
	skier.x = 250
	skier.y = 200
	skier.box = Collider:addRectangle(200, 80, 20, 16)
	skier.box.type = "skier"
	Collider:addToGroup("player", skier.box)
	skier.grind = Collider:addRectangle(200, 80, 48, 30)
	skier.grind.type = "grinder"
	Collider:addToGroup("player", skier.grind)
	skier.snow = love.graphics.newImage("gfx/snow.png")
	skier.particles = love.graphics.newParticleSystem(skier.snow, 64)
	skier.particles:setEmissionRate(32)
	skier.particles:setParticleLifetime(0.4)
	skier.particles:setPosition(0, 0)
	skier.particles:setDirection(4.5)
	skier.particles:setSpread(1)
	skier.particles:setSpeed(150, 200)
	skier.particles:stop()
end
function skier.update(dt)
	if skier.playbump == true then
		TEsound.play(skier.bump, "sfx")
		skier.playbump = false
	end
	if skier.isAlive == false then
		skier.explosion:update(dt)
		skier.speed = 0
		skier.y = skier.y - dt * speed
	else
		if bonus.timer > (0.0013 * speed) then
			score.value = score.value + bonus.value
			TEsound.play(bonus.sound)
			bonus_work()
			bonus.timer = 0
		end
	end
	skier.particles:start()
	skier.particles:update(dt)
	if skier.label == "skier" then
		skier.y = skier.y + (math.sin(math.rad(skier.angle)) - 0.94)
	elseif skier.label == "snowboarder" then
		skier.y = skier.y + (math.sin(math.rad(skier.angle)) - 0.98)
	end
	skier.x = skier.x + (skier.speed/50) * math.cos(math.rad(skier.angle))
	if love.keyboard.isDown("left") then
		if skier.label == "skier" then
			skier.angle = skier.angle + dt * 120
		elseif skier.label =="snowboarder" then
			skier.angle = skier.angle + dt * 200
			
		end
	elseif love.keyboard.isDown("right") then
		if skier.label == "skier" then
			skier.angle = skier.angle - dt * 100
		elseif skier.label =="snowboarder" then
			skier.angle = skier.angle - dt * 200
		end
	end
	skier.box:moveTo(skier.x, skier.y)
	skier.grind:moveTo(skier.x, skier.y)
	if skier.x < 16 then
		skier.x = 16
	elseif skier.x > 464 then
		skier.x = 464
	end
	if skier. y < 0 then
		TEsound.stop("sfx")
		TEsound.stop("music")
		if distance > record.best then
			record.best = distance
		end
		state = "game_over"
	end
end
function skier.draw()
	if skier.isAlive == true then
		love.graphics.draw(skier.particles, skier.x, skier.y)
		love.graphics.draw(skier.image, skier.x, skier.y, math.rad(skier.angle - 90), 1, 1, 16, 32)
	else
		skier.explosion:draw(skier.x - 16, skier.y - 32)
	end
	if dbug.show == true then
		skier.box:draw("line")
		love.graphics.setColor(0, 255, 0)
		skier.grind:draw("line")
		love.graphics.setColor(255, 255, 255)
	end
end
function bonus_work()
	local t = {}
	t.x = skier.x
	t.y = skier.y - 16
	t.alpha = 255
	table.insert(bonus.table, t)
end